<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
			text-align: left;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Query Results</h1>

		<p>There are several ways to generate query results in CarbonPHP.</p>
	</div>

	<div class="content">
		<h1>result()</h1>

		<p>This method returns the query result as an array of objects, or an empty array on failure.  Typically you'll
		use this in a <b>foreach ()</b> look like the following example.</p>

		<div class="example">
			$query = $this->db-query('SQL QUERY');<br />
			<br />
			foreach ($query->result() as $row)<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo $row->title;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo $row->author;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo $row->post;<br />
			&#125;
		</div>

		<p>This method is an alias of the <b>result_object()</b> method.  If you run queries that may not produce
		any results you are encouraged to test to see if there are any results.</p>

		<div class="example">
			$query = $this->db->query('SQL QUERY');<br />
			<br />
			if ($query->num_rows() > 0)<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;foreach ($query->result() as $row)<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo $row->title;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo $row->author;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo $row->post;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;
		</div>
	</div>

	<div class="content">
		<h1>result_array()</h1>

		<p>This method returns the query result as a pure array, on an empty array on failure.  Typically you will use
		this in a <b>foreach ()</b> loop like the following.</p>

		<div class="example">
			$query = $this->db-query('SQL QUERY');<br />
			<br />
			foreach ($query->result_array() as $row)<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo $row['title'];<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo $row['author'];<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo $row['post'];<br />
			&#125;
		</div>		
	</div>

	<div class="content">
		<h1>row()</h1>

		<p>The method returns a single result row.  If you query has more than one result in the row it returns only
		the first row.  The first is returned as an object.</p>

		<div class="example">
			$query = $this->db->query('SQL QUERY');<br />
			<br />
			if ($query->num_rows() > 0)<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;$row = $query->row();<br />
			<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo $row->title;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo $row->author;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo $row->post;<br />
			&#125;
		</div>

		<p>If you wish to return a specific row from the result set you can pass a digit as the parameter.</p>

		<div class="example">
			$row = $query->row(<b>4</b>);
		</div>
	</div>

	<div class="content">
		<h1>row_array()</h1>

		<p>This method is identical to the above <b>row()</b> method except that it will return the row as an array.</p>

		<div class="example">
			$query = $this->db->query('SQL QUERY');<br />
			<br />
			if ($query->num_rows() > 0)<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;$row = $query->row_array();<br />
			<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo $row['title'];<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo $row['author'];<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo $row['post'];<br />
			&#125;
		</div>

		<p>If you wish to return a specific row from the result set you can pass a digit as the parameter.</p>

		<div class="example">
			$row = $query->row_array(<b>6</b>);
		</div>

		<p>In addition to the above method you can also walk through the results forwards or backwards.  You can use
		the following methods.</p>

		<div class="example">
			$row = $query->first_row();<br />
			$row = $query->last_row();<br />
			$row = $query->next_row();<br />
			$row = $query->previous_row();
		</div>

		<p>By default they return an object unless you pass the parameter '<b>array</b>' like the following.</p>

		<div class="example">
			$row = $query->first_row('array');<br />
			$row = $query->last_row('array');<br />
			$row = $query->next_row('array');<br />
			$row = $query->previous_row('array') 
		</div>
	</div>

	<div class="content">
		<h1>num_rows()</h1>

		<p>This method returns the amount of rows that are returned by a query.</p>

		<div class="example">
			$query = $this->db->query('SELECT * FROM `some_table`');<br />
			<br />
			echo $query->num_rows();
		</div>
	</div>

	<div class="content">
		<h1>num_fields()</h1>

		<p>This method returns the number of fields returned by a query.</p>

		<div class="example">
			$query = $this->db->query('SELECT * FROM `some_table`');<br />
			<br />
			echo $query->num_fields();
		</div>
	</div>

	<div class="content">
		<h1>free_result()</h1>

		<p>This method will free the memory associated with the result and deletes the results resource ID.  Normally
		PHP frees its memory automatically at the end of the execution of the script.  However if you are running many
		queries in a speicifc script you may wish to free a result after each query to cut down on the memory usage.</p>

		<div class="example">
			$query = $this->db->query('SELECT `title` FROM `some_table`');<br />
			<br />
			foreach ($query->result() as $row)<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo $row->title;<br />
			&#125;<br />
			<br />
			$query->free_result();
			<br />
			$query2 = $this->db->query('SELECT `author` FROM `some_table`');<br />
			<br />
			$row = $query2->row();<br />
			echo $row->author;<br />
			<br />
			$query2->free_result();
		</div>
	</div>
</body>

</html>
